# $Header: /cvsroot/SchemaEditor/XSField.py,v 1.13 2003/09/05 15:16:24 spuelrich Exp $
__version__ = '$Revision: 1.13 $'[11:-2]

from Products.Formulator import StandardFields

class XSField:
    """a mixin class for the XMLSchema fields"""

    def render(self, xsi_node, value=None, REQUEST=None):
        """This does the trick, that a field is rendered with the nodepath of its corresponding
        xsi_node as fieldname instead of its id."""
        self.id = xsi_node.getNodePath('xsi')
        return self._render_helper(self.generate_field_key(), value, REQUEST)

    def validate(self, xsi_node, REQUEST):
        """this does the same trick as above, but validates."""
        self.id = xsi_node.getNodePath('xsi')
        return self._validate_helper(self.generate_field_key(validation=1), REQUEST)

    def get_form_encoding(self):
        return 'UTF-8'

class XSField_enumeration(XSField, StandardFields.ListField):
    meta_type = 'XSField_enumeration'

class XSField_int(XSField, StandardFields.IntegerField):
    meta_type = 'XSField_int'

class XSField_short(XSField, StandardFields.IntegerField):
    meta_type = 'XSField_short'
    
class XSField_string(XSField, StandardFields.StringField):
    meta_type = 'XSField_string'

class XSField_textArea(XSField, StandardFields.TextAreaField):
    meta_type = 'XSField_textArea'

class XSField_float(XSField, StandardFields.FloatField):
    meta_type = 'XSField_float'

class XSField_double(XSField, StandardFields.FloatField):
    meta_type = 'XSField_double'

class XSField_dateTime(XSField, StandardFields.DateTimeField):
    meta_type = 'XSField_dateTime'

class XSField_date(XSField, StandardFields.DateTimeField):
    meta_type = 'XSField_date'

class XSField_boolean(XSField, StandardFields.CheckBoxField):
    meta_type = 'XSField_boolean'

# there is no Formulator field for long values...
class XSField_integer(XSField, StandardFields.StringField):
    meta_type = 'XSField_integer'

class XSField_positiveInteger(XSField, StandardFields.StringField):
    meta_type = 'XSField_positiveInteger'

class XSField_nonNegativeInteger(XSField, StandardFields.StringField):
    meta_type = 'XSField_nonNegativeInteger'

class XSField_nonPositiveInteger(XSField, StandardFields.StringField):
    meta_type = 'XSField_nonPositiveInteger'

class XSField_negativeInteger(XSField, StandardFields.StringField):
    meta_type = 'XSField_negativeInteger'

class XSField_long(XSField, StandardFields.StringField):
    meta_type = 'XSField_long'

class XSField_byte(XSField, StandardFields.IntegerField):
    meta_type = 'XSField_byte'

class XSField_unsignedLong(XSField, StandardFields.StringField):
    meta_type = 'XSField_unsignedLong'

class XSField_unsignedInt(XSField, StandardFields.StringField):
    meta_type = 'XSField_unsignedInt'

class XSField_unsignedShort(XSField, StandardFields.IntegerField):
    meta_type = 'XSField_unsignedShort'

class XSField_unsignedByte(XSField, StandardFields.IntegerField):
    meta_type = 'XSField_unsignedByte'
