# $Header: /cvsroot/SchemaEditor/XSTypeRegistry.py,v 1.12 2003/09/05 15:16:24 spuelrich Exp $
__version__ = '$Revision: 1.12 $'[11:-2]

class XSTypeRegistry:
    """Every SchemaEditorSession has one Instance of this.
    Additionally there is one singleton instance, which contains all standard types."""

    def __init__(self):
        self.types_by_name = {}
        self.types_by_nodepath = {}

    def clear(self):
        self.types_by_name = {}
        self.types_by_nodepath = {}

    def register_type(self, type):
        # register type by name
        if type.name:
            self.types_by_name[type.name] = type
            self.types_by_name = self.types_by_name

        # register type by nodepath
        if type.nodepath:
            self.types_by_nodepath[type.nodepath] = type
            self.types_by_nodepath = self.types_by_nodepath

    def get_type(self, name=None, nodepath=None):
        """returns the type"""
        # unnamed types, type-attribute
        # XML&Co S 427
        if nodepath is not None and self.types_by_nodepath.has_key(nodepath):
            return self.types_by_nodepath[nodepath]
        elif name is not None and self.types_by_name.has_key(name):
            return self.types_by_name[name]
        elif self is not globalXSTypeRegistry:
            return globalXSTypeRegistry.get_type(name=name, nodepath=nodepath)
        else:
            return None

    def info(self):
        output = 'types by name\n'
        if self.types_by_name.items():
            for (name, type) in self.types_by_name.items():
                output += ' %s: %s\n' % (name, repr(type))
        else:
            output += ' None\n'
        output += '\ntypes by nodepath\n'
        if self.types_by_nodepath.items():
            for (path, type) in self.types_by_nodepath.items():
                output += ' %s: %s\n' % (path, repr(type))
        else:
            output += ' None\n'
        return output

globalXSTypeRegistry = XSTypeRegistry()
