# $Header: /cvsroot/SchemaEditor/__init__.py,v 1.11 2003/09/05 15:16:24 spuelrich Exp $
__doc__ = '''SchemaEditor Product Initialization
$Id: __init__.py,v 1.11 2003/09/05 15:16:24 spuelrich Exp $'''
__version__ = '$Revision: 1.11 $'[11:-2]

from Products.FileSystemSite.DirectoryView import registerDirectory
from Products.ParsedXML import NodePath
from Products.Formulator.FieldRegistry import initializeFieldForm

__allow_access_to_unprotected_subobjects__ = 1

def initialize(context):

    import XSField
    # initialize the field forms
    initializeFieldForm(XSField.XSField_int)
    initializeFieldForm(XSField.XSField_short)
    initializeFieldForm(XSField.XSField_string)
    initializeFieldForm(XSField.XSField_float)
    initializeFieldForm(XSField.XSField_double)
    initializeFieldForm(XSField.XSField_dateTime)
    initializeFieldForm(XSField.XSField_date)
    initializeFieldForm(XSField.XSField_boolean)

    import SchemaEditor
    context.registerClass(
            SchemaEditor.SchemaEditor,
            constructors=(('manage_addSchemaEditorForm',
                           SchemaEditor.manage_addSchemaEditorForm),
                          SchemaEditor.manage_addSchemaEditor),
            icon='www/xsd.png'
            )
    registerDirectory('widgets', globals())
    registerDirectory('globals', globals())

    from XSIPath import XSIPathScheme, XSIParentPathScheme, XSIBoundaryPathScheme
    NodePath.registry.register_scheme(XSIPathScheme('xsi'))
    NodePath.registry.register_scheme(XSIParentPathScheme('xsi_parent'))
    NodePath.registry.register_scheme(XSIBoundaryPathScheme('xsi_boundary'))

    from XSWebType import initialize_global_type_registry
    initialize_global_type_registry()
