# $Header: /cvsroot/SchemaEditor/install.py,v 1.24 2003/09/08 08:16:03 spuelrich Exp $
__version__ = '$Revision: 1.24 $'[11:-2]

from Globals import package_home
import os

from Products.FileSystemSite.DirectoryView import manage_listAvailableDirectories, createDirectoryView
widgetmodes = ('add', 'delete', 'edit', 'normal', 'replace', 'save')
elementmodes = {
    'schema':('add', 'edit', 'normal'),
    'annotation':('add', 'delete', 'edit', 'normal', 'replace', 'save'),
    'element':('add', 'delete', 'edit', 'normal', 'replace', 'save'),
    'complexType':('add', 'edit', 'normal', 'save'),
    'complexContent':('add', 'edit', 'normal', 'save'),
    'extension':('add', 'edit', 'normal', 'save'),
    'all':('edit', 'normal', 'add', 'save'),
    'sequence':('add', 'edit', 'normal', 'replace', 'save'),
    'choice':('add', 'edit', 'normal', 'replace', 'save'),
    'attribute':('add', 'edit', 'normal', 'save'),
    'simpleType':('add', 'edit', 'normal', 'save')
    }
XMLFiles =  ('all_xsd', 'all_xsi',
             'allTypes_xsd', 'allTypes_xsi',
             'choice_xsd', 'choice_xsi',
             'house_xsd', 'house_xsi',
             'house_extension_xsd',
             'guess_value_xsd', 'guess_value_xsi',
             'simpleType_list_xsd', 'simpleType_list_xsi',
             'pferdetherapie_xsd', 'pferdetherapie_xsi',
             'simpleTypes_xsd')

def install_helpers(container):
    create_xmlwidgets_objects(container)
    initialize_widget_registries(container)
    create_filesystem_views(container)
    # install standard_error_message
    add_zpt(container, 'standard_error_message', globals(), folder='www')
    return

def create_xmlwidgets_objects(container):
    container.manage_addProduct['XMLWidgets'].manage_addEditorService('service_editor')
    for wmode in widgetmodes:
        container.manage_addProduct['XMLWidgets'].manage_addWidgetRegistry('service_schema_%s' % wmode)
    return

def initialize_widget_registries(container):
    for wmode in widgetmodes:
        wr = getattr(container, 'service_schema_%s' % wmode)
        wr.clearWidgets()
        for element, modes in elementmodes.items():
            if wmode in modes:
                wr.addWidget('xsd:%s' % element, ('widgets', element, 'mode_%s' % wmode))
    return

def create_filesystem_views(container):
    from os.path import join
    for dir in manage_listAvailableDirectories():
        if (dir.endswith(join('Products', 'SchemaEditor', 'globals')) or
            dir.endswith(join('Products', 'SchemaEditor', 'widgets'))):
            createDirectoryView(container, dir)
    return

def install_demo(container):
    # create "demo" folder
    container.manage_addFolder('demo')
    folder = getattr(container, 'demo')
    
    # create demo xml documents
    for id in XMLFiles:
        add_px(folder, id, globals())
    # create an index_html PythonScript
    # it redirects the user to the "choose a XSI/XSD" form
    add_pyscript(container, 'index_html', globals())
    return

def add_pyscript(container, id, info, folder='demo'):
    filename = id + '.py'
    content = read_file(filename, info, folder)
    container.manage_addProduct['PythonScripts'].manage_addPythonScript(id)
    zscript = getattr(container, id)
    zscript.ZPythonScript_edit(params='',
                               body=content)
    return

def add_zpt(container, id, info, folder='demo'):
    filename = id + '.zpt'
    content = read_file(filename, info, folder)
    container.manage_addProduct['PageTemplates'].manage_addPageTemplate(id, id, content)
    return
    
def add_px(container, id, info, folder='demo'):
    filename = id + '.xml'
    content = read_file(filename, info, folder)
    container.manage_addProduct['ParsedXML'].manage_addParsedXML(id, file=content)
    return
    
def read_file(id, info, folder):
    filename = os.path.join(package_home(info), folder, id)
    f = open(filename, 'rb')
    text = f.read()
    f.close()
    return text
