## Script (Python) "render"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Header: /cvsroot/SchemaEditor/widgets/all/render.py,v 1.5 2003/09/01 07:59:38 spuelrich Exp $
from Products.SchemaEditor.xsdTools import getChildNodesByTagNameNS, XSUndeclaredElement
request = context.REQUEST
xsd_node = request.node
# remember: xsi_node is the first node _within_ the group
xsi_node = request.xsi_node
parent_node = xsi_node.parentNode
service_editor = context.service_editor

declarations = {}
for decl in getChildNodesByTagNameNS(xsd_node, 'element'):
    name = decl.getAttribute('name')
    declarations[name] = decl

# traverse the nodes in the XSI
output = ''
for instance in parent_node.childNodes:
    if instance.nodeType != instance.ELEMENT_NODE:
        continue
    myDeclaration = declarations.get(instance.tagName, None)
    if myDeclaration is None:
        # element without declaration
        info = context.schema_editor.pretty_print(instance)
        raise XSUndeclaredElement, 'undeclared element: %s' % info
    request.set('xsi_parent_node', parent_node)
    request.set('xsi_node', instance)
    output += service_editor.render(myDeclaration)
    # each declaration is restricted to instatiate only once
    del(declarations[instance.tagName])

# iterate over the remaining declarations
for myDeclaration in declarations.values():
    request.set('xsi_node', None)
    request.set('xsi_parent_node', parent_node)
    output += service_editor.render(myDeclaration)

return output
