## Script (Python) "render"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Header: /cvsroot/SchemaEditor/widgets/element/mode_add/render.py,v 1.14 2003/08/28 12:35:50 spuelrich Exp $
from Products.SchemaEditor.xsdTools import seURI
request = context.REQUEST
xsd_node = request.node
xsi_node = request.xsi_node
xsi_parent_node = request.xsi_parent_node
schema_editor = context.schema_editor

name = xsd_node.getAttribute('name')
minOccurs = schema_editor.getCardinality(xsd_node, 'minOccurs')
maxOccurs = schema_editor.getCardinality(xsd_node, 'maxOccurs')

# get type of declaration
type = schema_editor.get_element_type(xsd_node)

default_value = None
if type.has_simple_content():
   if xsd_node.hasAttributeNS(seURI, 'defaultValue'):
      default_value = type.get_nofacet_value(xsd_node.getAttributeNS(seURI, 'defaultValue'))

if xsd_node.hasAttributeNS(seURI, 'defaultOccurs'):
   defaultOccurs = schema_editor.getCardinality(xsd_node, 'defaultOccurs', seURI)
   if (defaultOccurs != 'unbounded' and
       defaultOccurs >= minOccurs and
       defaultOccurs <= maxOccurs):
      minOccurs = defaultOccurs

# this could be done with a documentFragment, but we will lose the
# references to the contained nodes after adding the fragment to the document.
new_node_list = []

for occurrence in range(minOccurs):
    # create new elementnode
    new_node = xsi_parent_node.ownerDocument.createElement(name)

    print 'added element: %s (%d/%d)' % (name, occurrence+1, minOccurs)

    # set node which contains the new content
    request.set('xsi_parent_node', new_node)

    # create content depending on type
    # returns a string with some debug messages
    print type.create_instance(context, default_value)

    # append new element to a temporary list
    new_node_list.append(new_node)

# reset parent node for following element creations
request.set('xsi_parent_node', xsi_parent_node)

if xsi_node is None:
    try:
        for node in new_node_list:
            xsi_parent_node.appendChild(node)
    except:
        pass
else:
    for node in new_node_list:
        xsi_parent_node.insertBefore(node, xsi_node)

if new_node_list:
    # this should be correct, because the top-most element will be created only once
    request.set('new_xsi_node', new_node_list[0])

return printed
