## Script (Python) "render"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Header: /cvsroot/SchemaEditor/widgets/element/render.py,v 1.31 2003/09/04 20:38:43 spuelrich Exp $
from Products.SchemaEditor.xsdTools import getNextElementSibling, xsdURI
request = context.REQUEST
schema_editor = context.schema_editor
xsd_node = request.node
xsi_node = request.xsi_node

# pre-calculate NodePaths
xsd_nodepath = xsd_node.getNodePath('widget')
if xsi_node is None:
   xsi_nodepath = None
else:
   xsi_nodepath = xsi_node.getNodePath('xsi')

name = xsd_node.getAttribute('name')
if not name:
   # XXX eigene Exception definieren
   raise KeyError, 'Kein name Attribut angegeben!'

type = schema_editor.get_element_type(xsd_node)

min = schema_editor.getCardinality(xsd_node, "minOccurs")
max = schema_editor.getCardinality(xsd_node, "maxOccurs")

infolink = context.get_info_link(xsd_nodepath)
deletelink = context.get_delete_link(xsi_nodepath, xsd_nodepath)

output = u'<div class="thinbox">'
occurs = 0
while (not (xsi_node is None or
            xsi_node.tagName != name or
            occurs == max)):

   if occurs > 0:
      # end the previous div-tag
      # the last closing tag is appended to the output outside the loop.
      # this way it is possible to add the add/edit/info/delete links on the
      # same line as the last element instance
      output += '</div>\n'
   output += '<div class="element">\n'

   # this grabs exactly the node to be edited.
   if schema_editor.is_edit_node(xsi_node, xsi_nodepath):
      output += context.start_form()
      end = context.end_form(xsi_nodepath, xsd_nodepath)
      editlink = ''
   else:
      # der link mu bereits hier erzeugt werden,
      # da das Rendern die Informationen im REQUEST verndert
      editlink = context.get_edit_link(xsi_nodepath, xsd_nodepath)
      end = ''
   doc_title = ''
   if getattr(type, 'get_info', None):
      doc_title = type.get_info()

   output += '<span class="tag">&lt;<span class="tagname" title="%s">%s</span>' % (doc_title, name)
   ## if getattr(type, 'render_attributes', None):
   ##    output += type.render_attributes(context)
   output += '&gt;</span>'
   output += type.render(context)
   output += '<span class="tag">&lt;/<span class="tagname">%s</span>&gt;</span>' % name
   output += editlink
   output += end
   occurs += 1
   xsi_node = getNextElementSibling(xsi_node)
   request.set('xsi_node', xsi_node)
   if xsi_node is None:
      xsi_nodepath = None
   else:
      xsi_nodepath = xsi_node.getNodePath('xsi')

# addlink darf erst _nach_ dem eigentlichen Rendern erzeugt werden.
# erst jetzt hat xsi-node einen verwertbaren Inhalt.
# allerdings ist request.xsd_node nicht mehr sinnvoll, da der durch das rendern verndert wird.
if occurs < max:
   addlink = context.get_add_link(xsi_nodepath, xsd_nodepath)
else:
   addlink = ''

if occurs <= min:
   deletelink = ''
   
output += ''.join((infolink, addlink, deletelink))
if occurs > 0:
   # um verschachtelte <choice> zu ermglichen
   request.schema_editor_choice_break[-1] = 1
   output += '\n</div><!-- element -->\n'
output += '\n</div><!-- thinbox -->\n'
return output

