## Script (Python) "replace"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Header: /cvsroot/SchemaEditor/widgets/replace.py,v 1.3 2003/09/02 09:31:49 spuelrich Exp $
from Products.PythonScripts.standard import html_quote
from Products.SchemaEditor.xsdTools import minimize_paths

request = context.REQUEST
xsd_node = request.node
xsi_node = request.xsi_node
xsi_boundary = request.xsi_boundary_node
schema_editor = context.schema_editor

# this is not called from schema_editor.renderContent()
# so we have to compute xsi_doc_path self
xsi_doc_path = xsi_node.ownerDocument.getPhysicalPath()

frag = xsi_node.ownerDocument.createDocumentFragment()

# initialize REQUEST
request.set('xsi_parent_node', frag)
request.set('xsi_node', None)

# create the new sub-tree
context.service_editor.setDocumentEditor(xsd_node.documentElement, 'service_schema_add')
result = context.service_editor.render(xsd_node)

# now all new nodes lie in frag

# delete the old nodes
node = xsi_node
parent = xsi_node.parentNode
while (node is not None and node != xsi_boundary):
    next = node.nextSibling
    parent.removeChild(node)
    node = next

# "for node in frag" does not work properly. don't know why.
new_nodes = [node for node in frag]
# insert the new nodes
if xsi_boundary is None:
    for node in new_nodes:
        parent.appendChild(node)
else:
    for node in new_nodes:
        parent.insertBefore(node, xsi_boundary)

# cleanup in session
context.service_editor.clearNodeWidget(xsd_node)
context.schema_editor.clear_edit_node()

# get_redirect_url() needs request.node and request.xsi_node properly set
request.set('xsi_node', parent)

url = schema_editor.get_redirect_url()
if schema_editor.debug_mode(request, 'show_steps'):
    return schema_editor.result_page(result=result, continue_url=url)
else:
    request.RESPONSE.redirect(url)
    return ''
